Combining multiple Bryntum products

Thin packages overview

Bryntum products share the same data model and can be combined to provide different views of the underlying data.

When combining multiple Bryntum products in a single application using JavaScript, you should use thin npm packages. The main difference between thin packages and regular packages is that thin only contain product specific code and styling, while regular contain code and styling for all underlying products (for example Scheduler includes Scheduler + Grid + Core). Thin packages are also valid for building a single product application.

It is not possible to import several regular (non-thin) Bryntum npm packages like @bryntum/grid and @bryntum/calendar in one application. Doing this will lead to a runtime console error:

The Bryntum Grid bundle was loaded multiple times by the application.

Do not mix regular (e.g., @bryntum/grid) and thin (e.g., @bryntum/grid-thin) packages in the same project. If using thin packages, remove regular ones and follow this guide to install all required dependencies.

Thin packages list

Bryntum's npm repository contains thin packages for combining multiple Bryntum products in one application.

Thin limited trial library packages:

PackagePurpose
@bryntum/core-thin-trialBryntum Core data and UI trial components package
@bryntum/grid-thin-trialBryntum Grid trial components package
@bryntum/scheduler-thin-trialBryntum Scheduler trial components package
@bryntum/schedulerpro-thin-trialBryntum Scheduler Pro trial components package
@bryntum/gantt-thin-trialBryntum Gantt trial components package
@bryntum/calendar-thin-trialBryntum Calendar trial components package
@bryntum/taskboard-thin-trialBryntum TaskBoard trial components package
@bryntum/engine-thin-trialBryntum Scheduling engine trial components package

To use framework wrappers, trial packages listed above require aliasing the @bryntum/-thin-trial package as @bryntum/-thin during installation, as shown below. Once installed, the provided app code samples can be used without modification

Example for @bryntum/grid-thin-trial package:

npm install @bryntum/grid-thin@npm:@bryntum/[email protected]

Alternatively, you can directly add entries to the "dependencies" section of the package.json project file as follows:

"dependencies": {
  "@bryntum/grid-thin": "npm:@bryntum/[email protected]",
}

Thin licensed library packages:

PackagePurpose
@bryntum/core-thinBryntum Core data and UI components package
@bryntum/grid-thinBryntum Grid components package
@bryntum/scheduler-thinBryntum Scheduler components package
@bryntum/schedulerpro-thinBryntum Scheduler Pro components package
@bryntum/gantt-thinBryntum Gantt components package
@bryntum/calendar-thinBryntum Calendar components package
@bryntum/taskboard-thinBryntum TaskBoard components package
@bryntum/engine-thinBryntum Scheduling engine components package

Thin JavaScript wrapper packages:

PackagePurpose
@bryntum/core-js-thinBryntum Core UI widgets JavaScript wrappers package
@bryntum/grid-js-thinBryntum Grid JavaScript wrapper package
@bryntum/scheduler-js-thinBryntum Scheduler JavaScript wrapper package
@bryntum/schedulerpro-js-thinBryntum Scheduler Pro JavaScript wrapper package
@bryntum/gantt-js-thinBryntum Gantt JavaScript wrapper package
@bryntum/calendar-js-thinBryntum Calendar JavaScript wrapper package
@bryntum/taskboard-js-thinBryntum TaskBoard JavaScript wrapper package

Package dependencies

Each package contains code related to the specific product only and requires installing dependency packages for all underlying products. This is not done automatically to give you full control over the installed packages.

List of required dependencies used in package.json for JavaScript application:

{
  "dependencies": {
    "@bryntum/core-thin": "7.2.0-alpha-1",
    "@bryntum/grid-thin": "7.2.0-alpha-1"
  }
}

Product styling

List of required styles for JavaScript application style.css/scss:

SCSS/CSS:

/* FontAwesome is used for icons */
@import '@bryntum/core-thin/fontawesome/css/fontawesome.css';
@import "@bryntum/core-thin/fontawesome/css/solid.css";
/* Structural CSS */
@import '@bryntum/core-thin/core.css';
@import '@bryntum/grid-thin/grid.css';
/* Theme */
@import '@bryntum/core-thin/svalbard-light.css';

Product template

Example of configuring product template for JavaScript application main.js:

This guide assumes that you're using Vite to set up your project. Otherwise, to render the styles correctly, you must have a div container with id="app" in your index.html.

import { Grid } from '@bryntum/grid-thin';
import './style.css';

const grid = new Grid({
    appendTo : 'app',
    columns  : [
        { field : 'name', text : 'Name', width : 200 },
        { field : 'city', text : 'City', flex : 1 }
    ],
    data : [
        { name : 'Dan Stevenson', city : 'Los Angeles' },
        { name : 'Talisha Babin', city : 'Paris' }
    ]
});

Non-npm packages

If you're not using npm, you can use module or UMD bundles.

Thin module bundle

Similar to npm packages, thin module bundles contain code for one specific product, which means that it has a much smaller size, but you have to use multiple bundles to get anything working (Grid for example has to pull in the Core bundle to work). Here's an example:

// Import 3 classes separately from different thin bundles
import { Store } from 'core.module.thin.js';
import { Grid } from 'grid.module.thin.js';
import { Scheduler } from 'scheduler.module.thin.js';

UMD bundle

The umd bundle (scheduler.umd.js importable as a good old script tag, exposes all classes globally) is to be considered legacy. Using it is not something we recommend unless your environment prevents you from using a more modern bundle. It will not allow you to combine multiple products very well. Below you find a snippet here for completeness:

<!-- Script tag in your html file -->
<script src="scheduler.umd.js"></script>
// No imports needed, classes are exposed to window.bryntum.scheduler
const { Store, Grid, Scheduler } = window.bryntum.scheduler;

Combining products

You can combine multiple products and have them on the same page. For example, if you want to combine Grid and Scheduler, you can have them like the following:

import { Grid } from "@bryntum/grid-thin";
import { Scheduler } from "@bryntum/scheduler-thin";
import "./style.css"; // import styles

const grid = new Grid({
  appendTo: "app",
  columns: [
    { field: "name", text: "Name", width: 200 },
    { field: "city", text: "City", flex: 1 },
  ],
  data: [
    { name: "Dan Stevenson", city: "Los Angeles" },
    { name: "Talisha Babin", city: "Paris" },
  ],
});

const scheduler = new Scheduler({
  appendTo: "app",
  startDate: new Date(2022, 0, 1),
  endDate: new Date(2022, 0, 10),
  columns: [{ text: "Name", field: "name", width: 160 }],
  resources: [
    { id: 1, name: "Dan Stevenson" },
    { id: 2, name: "Talisha Babin" },
  ],
  events: [
    { resourceId: 1, startDate: "2022-01-01", endDate: "2022-01-10" },
    { resourceId: 2, startDate: "2022-01-02", endDate: "2022-01-09" },
  ],
});

Combining multiple Bryntum products

Thin packages overview

Bryntum's products share the same data model and can be combined to provide different views of the underlying data.

When combining multiple Bryntum products in a single application using Vue, you should use thin npm packages. This avoids runtime errors and also reduces the amount of code and CSS that has to be downloaded.

The main difference between thin packages and regular packages is that thin only contain product specific code and styling, while regular contain code and styling for all underlying products (for example Scheduler includes Scheduler + Grid + Core). Thin packages are valid for building a single product application.

It is not possible to import several regular (non-thin) Bryntum npm packages like @bryntum/grid and @bryntum/calendar in one application. Doing this will lead to a runtime console error:

The Bryntum Grid bundle was loaded multiple times by the application.

Do not mix regular (e.g., @bryntum/grid) and thin (e.g., @bryntum/grid-thin) packages in the same project. If using thin packages, remove regular ones and follow this guide to install all required dependencies.

Thin packages list

Bryntum's npm repository contains thin packages for combining multiple Bryntum products in one application.

Thin limited trial library packages:

PackagePurpose
@bryntum/core-thin-trialBryntum Core data and UI trial components package
@bryntum/grid-thin-trialBryntum Grid trial components package
@bryntum/scheduler-thin-trialBryntum Scheduler trial components package
@bryntum/schedulerpro-thin-trialBryntum Scheduler Pro trial components package
@bryntum/gantt-thin-trialBryntum Gantt trial components package
@bryntum/calendar-thin-trialBryntum Calendar trial components package
@bryntum/taskboard-thin-trialBryntum TaskBoard trial components package
@bryntum/engine-thin-trialBryntum Scheduling engine trial components package

To use framework wrappers, trial packages listed above require aliasing the @bryntum/-thin-trial package as @bryntum/-thin during installation, as shown below. Once installed, the provided app code samples can be used without modification

Example for @bryntum/grid-thin-trial package:

npm install @bryntum/grid-thin@npm:@bryntum/[email protected]

Alternatively, you can directly add entries to the "dependencies" section of the package.json project file as follows:

"dependencies": {
  "@bryntum/grid-thin": "npm:@bryntum/[email protected]",
}

Thin licensed library packages:

PackagePurpose
@bryntum/core-thinBryntum Core data and UI components package
@bryntum/grid-thinBryntum Grid components package
@bryntum/scheduler-thinBryntum Scheduler components package
@bryntum/schedulerpro-thinBryntum Scheduler Pro components package
@bryntum/gantt-thinBryntum Gantt components package
@bryntum/calendar-thinBryntum Calendar components package
@bryntum/taskboard-thinBryntum TaskBoard components package
@bryntum/engine-thinBryntum Scheduling engine components package

Thin Vue 3 wrapper packages:

PackagePurpose
@bryntum/core-vue-3-thinBryntum Core UI widgets Vue 3 wrappers package
@bryntum/grid-vue-3-thinBryntum Grid Vue 3 wrapper package
@bryntum/scheduler-vue-3-thinBryntum Scheduler Vue 3 wrapper package
@bryntum/schedulerpro-vue-3-thinBryntum Scheduler Pro Vue 3 wrapper package
@bryntum/gantt-vue-3-thinBryntum Gantt Vue 3 wrapper package
@bryntum/calendar-vue-3-thinBryntum Calendar Vue 3 wrapper package
@bryntum/taskboard-vue-3-thinBryntum TaskBoard Vue 3 wrapper package

Package dependencies

Each package contains code related to the specific product only and requires installing a dependency packages for all underlying products. This is not done automatically to give you full control over the installed packages.

List of required dependencies used in package.json for Vue 3 application:

@bryntum/core-vue-3-thin is listed among the available framework wrapper packages, but you only need to install it if you use Bryntum Core UI widgets in your app (e.g., BryntumButton, BryntumCombo etc.). It's not needed otherwise.
However, you should always install all API packages as they are required for the proper functioning.

Please note that you need an active license for each product to use it in the UI.

API packages:

{
  "dependencies": {
    "@bryntum/core-thin": "7.2.0-alpha-1",
    "@bryntum/grid-thin": "7.2.0-alpha-1"
  }
}

Framework wrapper packages:

{
  "dependencies": {
    "@bryntum/core-vue-3-thin": "7.2.0-alpha-1",
    "@bryntum/grid-vue-3-thin": "7.2.0-alpha-1"
  }
}

Product configuration

Importing product configuration for Vue 3 application app.config.tsx:

import { BryntumGridProps } from '@bryntum/grid-vue-3-thin';

const gridProps : BryntumGridProps = {
    // Grid configuration
};

Product localization

For a complete localization information please check localization guide.

Localization can be done using these two methods:

Using source code

Import product locale from a thin package in your application

Example for German De locale:

import '@bryntum/grid-thin/lib/localization/De.js'

Using prebuilt full locale

Import full UMD locale from the installed @bryntum package.

Example for De locale:

import '@bryntum/grid-thin/lib/locales/grid.locale.De.js'

Full locale can also be added to the index.html file of your application. You need to copy locales from the installed @bryntum package to a folder located at PATH_TO_LOCALE first, and then add this script to the application's home page.

Example for Grid product and German De locale:

<script src="PATH_TO_LOCALE/locales/grid.locale.De.js"></script>

Product styling

List of required styles for Vue application App.scss:

SCSS/CSS:

/* FontAwesome is used for icons */
@import '@bryntum/core-thin/fontawesome/css/fontawesome.css';
@import "@bryntum/core-thin/fontawesome/css/solid.css";
/* Structural CSS */
@import '@bryntum/core-thin/core.css';
@import '@bryntum/grid-thin/grid.css';
/* Theme */
@import '@bryntum/core-thin/svalbard-light.css';

Product template

Example of configuring product template for Vue application App.vue:

<script setup>
import { createApp, ref } from 'vue';

import { BryntumGrid } from '@bryntum/grid-vue-3-thin';
import { gridProps } from './AppConfig';

import './App.scss';

createApp({
});
</script>

<template>
    <bryntum-grid
        v-bind=gridProps
    />
</template>

<style lang="scss">
</style>

Technical demo

Technical demo showing all products in one application can be seen here. You may download source there clicking on Download header icon.

Combining multiple Bryntum products

Thin packages overview

Bryntum's products share the same data model and can be combined to provide different views of the underlying data.

When combining multiple Bryntum products in a single application using Angular, you should use thin npm packages. This avoids runtime errors and also reduces the amount of code and CSS that has to be downloaded.

The main difference between thin packages and regular packages is that thin only contain product specific code and styling, while regular contain code and styling for all underlying products (for example Scheduler includes Scheduler + Grid + Core). Thin packages are valid for building a single product application.

It is not possible to import several regular (non-thin) Bryntum npm packages like @bryntum/grid and @bryntum/calendar in one application. Doing this will lead to a runtime console error:

The Bryntum Grid bundle was loaded multiple times by the application.

Do not mix regular (e.g., @bryntum/grid) and thin (e.g., @bryntum/grid-thin) packages in the same project. If using thin packages, remove regular ones and follow this guide to install all required dependencies.

Thin packages list

Bryntum's npm repository contains thin packages for combining multiple Bryntum products in one application.

Thin limited trial library packages:

PackagePurpose
@bryntum/core-thin-trialBryntum Core data and UI trial components package
@bryntum/grid-thin-trialBryntum Grid trial components package
@bryntum/scheduler-thin-trialBryntum Scheduler trial components package
@bryntum/schedulerpro-thin-trialBryntum Scheduler Pro trial components package
@bryntum/gantt-thin-trialBryntum Gantt trial components package
@bryntum/calendar-thin-trialBryntum Calendar trial components package
@bryntum/taskboard-thin-trialBryntum TaskBoard trial components package
@bryntum/engine-thin-trialBryntum Scheduling engine trial components package

To use framework wrappers, trial packages listed above require aliasing the @bryntum/-thin-trial package as @bryntum/-thin during installation, as shown below. Once installed, the provided app code samples can be used without modification

Example for @bryntum/grid-thin-trial package:

npm install @bryntum/grid-thin@npm:@bryntum/[email protected]

Alternatively, you can directly add entries to the "dependencies" section of the package.json project file as follows:

"dependencies": {
  "@bryntum/grid-thin": "npm:@bryntum/[email protected]",
}

Thin licensed library packages:

PackagePurpose
@bryntum/core-thinBryntum Core data and UI components package
@bryntum/grid-thinBryntum Grid components package
@bryntum/scheduler-thinBryntum Scheduler components package
@bryntum/schedulerpro-thinBryntum Scheduler Pro components package
@bryntum/gantt-thinBryntum Gantt components package
@bryntum/calendar-thinBryntum Calendar components package
@bryntum/taskboard-thinBryntum TaskBoard components package
@bryntum/engine-thinBryntum Scheduling engine components package

Thin Angular wrapper packages:

PackagePurpose
@bryntum/core-angular-thinBryntum Core UI widgets Angular wrappers package
@bryntum/grid-angular-thinBryntum Grid Angular wrapper package
@bryntum/scheduler-angular-thinBryntum Scheduler Angular wrapper package
@bryntum/schedulerpro-angular-thinBryntum Scheduler Pro Angular wrapper package
@bryntum/gantt-angular-thinBryntum Gantt Angular wrapper package
@bryntum/calendar-angular-thinBryntum Calendar Angular wrapper package
@bryntum/taskboard-angular-thinBryntum TaskBoard Angular wrapper package

Package dependencies

Each package contains code related to the specific product only and requires installing a dependency packages for all underlying products. This is not done automatically to give you full control over the installed packages.

List of required dependencies used in package.json for Angular application:

@bryntum/core-angular-thin is listed among the available framework wrapper packages, but you only need to install it if you use Bryntum Core UI widgets in your app (e.g., BryntumButton, BryntumCombo etc.). It's not needed otherwise.
However, you should always install all API packages as they are required for the proper functioning.

Please note that you need an active license for each product to use it in the UI.

API packages:

{
  "dependencies": {
    "@bryntum/core-thin": "7.2.0-alpha-1",
    "@bryntum/grid-thin": "7.2.0-alpha-1"
  }
}

Framework wrapper packages:

{
  "dependencies": {
    "@bryntum/core-angular-thin": "7.2.0-alpha-1",
    "@bryntum/grid-angular-thin": "7.2.0-alpha-1"
  }
}

Modules configuration

Importing package module for Angular application app.module.ts:

import { NgModule } from '@angular/core'; import { BrowserModule } from '@angular/platform-browser';

import { BryntumCoreModule } from '@bryntum/core-angular-thin'; import { BryntumGridModule } from '@bryntum/grid-angular-thin';

import { AppComponent } from './app';

@NgModule({ declarations : [ AppComponent ], imports : [ BrowserModule, BryntumCoreModule, BryntumGridModule ], providers : [], bootstrap : [AppComponent] }) export class AppModule {}

Product localization

For a complete localization information please check localization guide.

Localization can be done using these two methods:

Using source code

Import product locale from a thin package in your application

Example for German De locale:

import '@bryntum/grid-thin/lib/localization/De.js'

Using prebuilt full locale

Import full UMD locale from the installed @bryntum package.

Example for De locale:

import '@bryntum/grid-thin/lib/locales/grid.locale.De.js'

Full locale can also be added to the index.html file of your application. You need to copy locales from the installed @bryntum package to a folder located at PATH_TO_LOCALE first, and then add this script to the application's home page.

Example for Grid product and German De locale:

<script src="PATH_TO_LOCALE/locales/grid.locale.De.js"></script>

Product configuration

Importing product configuration for Angular application app.config.tsx:

import { BryntumGridProps } from '@bryntum/grid-angular-thin';

const gridProps : BryntumGridProps = {
    // Grid configuration
};

Product styling

List of required styles for Angular application app.component.scss:

SCSS/CSS:

/* FontAwesome is used for icons */
@import '@bryntum/core-thin/fontawesome/css/fontawesome.css';
@import "@bryntum/core-thin/fontawesome/css/solid.css";
/* Structural CSS */
@import '@bryntum/core-thin/core.css';
@import '@bryntum/grid-thin/grid.css';
/* Theme */
@import '@bryntum/core-thin/material3-light.css';

If you import styles from *.css files, please ensure that fonts from @bryntum/core-thin are copied to assets.

Add this to angular.json file:

"assets": [
  {
    "glob": "**/*",
    "input": "node_modules/@bryntum/core-thin/fonts",
    "output": "assets/fonts"
  },
  ...
],

These setup is also required for styling.

Add to app.component.scss before importing component styles:

// This is required to setup font locations for Angular SCSS preprocessor
$fa-font-path  : '../../fonts';
$roboto-font-path : '../../../fonts';

Product template

Example of configuring product template for Angular application app.component.html:

<bryntum-grid
    #grid
    ...
></bryntum-grid>

Technical demo

Technical demo showing all products in one application can be seen here. You may download source there clicking on Download header icon.